#! /usr/bin/perl

use strict;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use URI::Escape;
use LWP::UserAgent;

my $cgi = new CGI;

my $daten;

if ($ENV{'REQUEST_METHOD'} eq 'POST')
{
	read (STDIN, $daten, $ENV{'CONTENT_LENGTH'});
}


my @feld = split(/&/,$daten);

# Hier werden dann die Daten verarbeitet, sodass nachher folgende Daten zur Verfgung stehen.

# $user  Benutzername
# $pw  Passwort
# $jobid  Caption
# $msg  Nachricht
# $msgtyp  Nachrichtentyp
# $sender  Absender

my $user = "test";
my $pw  = "test";
my $msgtyp  = 18; # mit absenderkennung
#my $msgtyp  = 6; # ohne absenderkennung
my $caption = "SMS gesendet ber Perl";

# $rcp  Empfnger(Entweder einfacher String mit ; als Trennzeichen)
# @rcp  Empfnger(oder als Array)  (bitte passendes stehenlassen und andere Mglichkeit lschen)

#--------------------------------------------------


print $cgi->header(),
		$cgi->start_html("SMS Versand"),
		$cgi->h1("SMS Versand"),
		$cgi->a({-href=>"http://smscreator.de"},"smscreator.de"),
		$cgi->startform(),
		$cgi->p,
		"Absender ",
		$cgi->textfield(-name=>'txtAbsender',
						  -default=>'',
						  -size=>30,
						  -maxlength=>50),
		$cgi->p,
		"Empfnger ",
		$cgi->textfield(-name=>'txtEmpfaenger',
						  -default=>'',
						  -size=>30,
						  -maxlength=>50),
		$cgi->p,
		"SMSText ",
		$cgi->textarea(-name=>'txtSMSText',
						  -default=>'',
						  -size=>30,
						  -maxlength=>50),
		$cgi->p,
		$cgi->submit(-name=>'abschicken',
					   -value=>'Senden ...'),
		$cgi->endform;


if (length($cgi->param('txtAbsender'))> 0 && length($cgi->param('txtEmpfaenger'))> 0 && length($cgi->param('txtSMSText'))> 0) {
	
	my $msg  = $cgi->param('txtSMSText');
    my $sender  = $cgi->param('txtAbsender');
    my $recipient  = $cgi->param('txtEmpfaenger');

	my $JobId = &sendsms($user, $pw,$msg,$recipient,$msgtyp,$sender,"",$caption);

	if ($JobId =~ /^OK/) {
		print $cgi->p,$cgi->h1("Die SMS wurde mit der JobId: " . $JobId . " an das Gateway bergeben"),
	} else {
		print $cgi->p,$cgi->h1("Es ist ein Fehler aufgetreten: ".$JobId),
	}

#Hier dann ein Hinweis, ob das Versenden erfolgreich war oder nicht.


}
print 		$cgi->end_html();



exit 0;




sub sendsms
{
  my ($User, $Password,$Msg,$Recipient,$SMSType,$Sender,$DateTime,$Caption) = @_;
  my @res = split(",",$Recipient);
  $Msg = substr($Msg, 0, 160);

# GET /Send.asmx/SendText?User=string&Password=string&Caption=string&Sender=string&Recipient=string&SMSText=string&SmsTyp=string&SendDate=string HTTP/1.1
# Host: soap.smscreator.de
  my $Uri = "http://soap.smscreator.de/Send.asmx/SendText";
  $Uri    .= "?User=" . uri_escape($User);
  $Uri    .= "&Password=" . uri_escape($Password);
  $Uri    .= "&Caption=" . uri_escape($Caption);
  $Uri    .= "&Sender=" . uri_escape($Sender);
  $Uri    .= "&SMSText=" . uri_escape($Msg);
  $Uri    .= "&SmsTyp=" . uri_escape($SMSType);
  $Uri    .= "&SendDate=" . uri_escape($DateTime);
  $Uri    .= "&Recipient=" . uri_escape(join("\n",@res));

  my $res = "";
  my $ua = LWP::UserAgent->new();
  my $request = HTTP::Request->new('GET', $Uri);
  my $response = $ua->request($request);
  
  if ( $response->is_error() ) { 
        $res .= "Error-Code    : ", $response->code() ,    "\n";
        $res .= "Fehlermeldung:  ", $response->message() , "\n";
  }
  else {
        if ($response->content()=~ /SendSMS\">(.*)<\/string>/) {
			$res =  $1;
        } else {
			$res = $response->content();
		}
        
  }

  return $res;
}
